#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include <math.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <inttypes.h>

#include "monomial.h"

int main(int argc, char *argv[])
{
    monomial_t * list;
    uint32_t i;
    uint32_t len;
    char * out;
    
    long N = 1000000;
    time_t  t0, t1;  // time_t is defined on <time.h> and <sys/types.h> as long
    clock_t c0, c1;  // clock_t is defined on <time.h> and <sys/types.h> as int
    long count;
    long double cputime;
    long double cputimepr;
    
    ///////////////////////////////////////////////////////////////////////////
    // GENERATE_BY_DEGREE
    
    printf("Generating all monomials in X, Y, Z of degree 30\n");
    
    t0 = time(NULL);
    c0 = clock();
    
    printf ("\tbegin (wall):            %ld\n", (long) t0);
    printf ("\tbegin (CPU):             %d\n", (int) c0);
    for (count = 0; count < N; count++)
    {
        list = mon_generate_by_degree(&len, 2, 30);
        free(list);
    }
    t1 = time(NULL);
    c1 = clock();
    
    cputime   = ((long double) (c1 - c0)) / ((long double) CLOCKS_PER_SEC);
    cputimepr = cputime / ((long double) N);
    
    printf ("\tend (wall):               %ld\n", (long) t1);
    printf ("\tend (CPU);                %d\n", (int) c1);
    printf ("\telapsed wall clock time:  %ld\n", (long) (t1 - t0));
    printf ("\telapsed CPU time:         %LG\n", cputime);
    printf ("\telapsed CPU time per run: %LG\n", cputimepr);
}

